<script lang="ts">
import Vue from "vue";
import { SlpButton, SlpTypography } from "slippers-ui";
import SearchIcon from "../../assets/search.vue";

/**
 * Component that receives an array of suggestions that is fetch in the SearchContent component
 * If the suggestions array is empty, the component will show some default searchTerms
 * After a suggestion is selected it will be passed to the parent component to do the search
 */
export default Vue.extend({
  name: "SlpSearchSuggestions",
  components: { SlpButton, SlpTypography, SearchIcon },
  data() {
    return {
      defaultSuggestions: [
        {
          text: "GitLab Duo (AI)",
          href: "https://about.gitlab.com/gitlab-duo/",
        },
        {
          text: "Code Suggestions (AI)",
          href: "https://about.gitlab.com/solutions/code-suggestions/",
        },
        {
          text: "CI/CD",
          href: "https://about.gitlab.com/features/continuous-integration/",
        },
        {
          text: "GitLab on AWS",
          href: "https://about.gitlab.com/partners/technology-partners/aws/",
        },
        {
          text: "GitLab on Google Cloud",
          href: "https://about.gitlab.com/partners/technology-partners/google-cloud-platform/",
        },
        {
          text: "Why GitLab?",
          href: "https://about.gitlab.com/why-gitlab/",
        },
      ],
    };
  },
  props: {
    searchSuggestions: {
      type: Array,
      required: false,
      default: () => [],
    },
  },
  methods: {
    onSelectSuggestion(suggestion: string) {
      this.$emit("suggestionSelect", suggestion);
    },
  },
  computed: {
    isMobile() {
      return window.matchMedia("only screen and (max-width: 732px)").matches;
    },
  },
});
</script>

<template>
  <div class="be-nav-suggestions">
    <SlpTypography tag="span" variant="body1" class="slp-mb-24"
      >Suggestions
    </SlpTypography>
    <div
      v-if="!searchSuggestions.length && !isMobile"
      class="be-nav-suggestions__default"
    >
      <SlpButton
        v-for="(suggestion, index) in defaultSuggestions"
        :key="`${suggestion.text}-${index}`"
        class="be-nav-suggestions__default-btn"
        :href="suggestion.href"
        :data-ga-name="suggestion.text"
        data-ga-location="search"
        target="_blank"
        @click.native="
          !suggestion.href ? onSelectSuggestion(suggestion.text) : () => ({})
        "
      >
        {{ suggestion.text }}
      </SlpButton>
    </div>
    <div v-if="!searchSuggestions.length && isMobile">
      <div
        v-for="suggestion in defaultSuggestions"
        :key="suggestion.text"
        class="be-nav-suggestions__result"
      >
        <div class="be-nav-suggestions__result--icon">
          <SearchIcon fill="#171321" />
        </div>
        <SlpButton
          variant="tertiary"
          @click.native="onSelectSuggestion(suggestion.text)"
          :data-ga-name="suggestion.text"
          data-ga-location="search"
          ><span>{{ suggestion.text }}</span></SlpButton
        >
      </div>
    </div>
    <div v-else>
      <div
        v-for="(suggestion, index) in searchSuggestions"
        :key="`${suggestion.title}-${index}`"
        class="be-nav-suggestions__result"
      >
        <div class="be-nav-suggestions__result--icon">
          <SearchIcon fill="#171321" />
        </div>
        <SlpButton
          variant="tertiary"
          :data-ga-name="suggestion.title"
          data-ga-location="search"
          @click.native="onSelectSuggestion(suggestion.title)"
          ><span>{{ suggestion.title }}</span></SlpButton
        >
      </div>
    </div>
  </div>
</template>

<style lang="scss">
.be-nav-suggestions {
  @media (max-width: $breakpoint-md) {
    width: 100vw;
  }
  &__default {
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;

    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }

  &__default-btn {
    max-width: 260px;
    width: 100%;
    margin-bottom: $spacing-16;
    background-color: $color-surface-800 !important;
    color: $color-text-300 !important;
    border: none !important;
    justify-content: center;
    transition: all 0.3s ease-in-out;

    @media (max-width: $breakpoint-lg) {
      max-width: 100%;
    }

    &:hover {
      background-color: #e3d6ff !important;
    }
  }

  &__result {
    display: flex;
    align-items: center;

    &--icon {
      min-width: 16px;

      svg {
        min-height: 16px;
        min-width: 16px;
      }
    }

    .slp-btn {
      color: $color-text-link-100;
      font-weight: 400;

      &:hover {
        text-decoration-color: $color-text-link-100;
      }

      @media (max-width: $breakpoint-md) {
        padding-left: 8px !important;
      }

      span {
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
      }
    }
  }
}
</style>
